CREATE TABLE CUSTOMER  (
		  PKEY VARCHAR2(10) NOT NULL PRIMARY KEY, 
		  FNAME VARCHAR2(20) , 
		  LNAME VARCHAR2(20) , 
		  CCODE VARCHAR2(10) ) ;
/
CREATE SEQUENCE EVENT_SEQ INCREMENT BY 1 START WITH 1 MINVALUE 1 CACHE 20 ;
/
CREATE TABLE WBIA_JDBC_EVENTSTORE
(
	EVENT_ID INTEGER NOT NULL 	PRIMARY KEY,
	XID				VARCHAR2(200),
	OBJECT_KEY			VARCHAR2(80)		NOT NULL,
	OBJECT_NAME		VARCHAR2(40)		NOT NULL,
	OBJECT_FUNCTION		VARCHAR2(40)		NOT NULL,
	EVENT_PRIORITY    		INTEGER			NOT NULL,
	EVENT_TIME			TIMESTAMP,		
	EVENT_STATUS		INTEGER			NOT NULL,
	EVENT_COMMENT		VARCHAR2(100)
);
/

CREATE OR REPLACE TRIGGER EVENT_CREATE AFTER INSERT ON CUSTOMER 
REFERENCING OLD AS O NEW AS N 
FOR EACH ROW 
BEGIN
INSERT INTO wbia_jdbc_eventstore (event_id, object_key, object_name,object_function, event_priority, event_status)
VALUES (event_seq.nextval,:N.pkey, 'JabdullaCustomerBG', 'Create', 1, 0);
END;
/

CREATE OR REPLACE TRIGGER EVENT_DELETE AFTER DELETE ON CUSTOMER 
REFERENCING OLD AS O NEW AS N 
FOR EACH ROW 
BEGIN
INSERT INTO wbia_jdbc_eventstore (event_id, object_key, object_name,object_function, event_priority, event_status)
VALUES (event_seq.nextval,:O.pkey, 'JabdullaCustomerBG', 'Delete', 1, 0);
END;
/

CREATE OR REPLACE TRIGGER EVENT_UPDATE AFTER UPDATE OF PKEY,  CCODE,  FNAME, LNAME ON CUSTOMER 
REFERENCING OLD AS O NEW AS N 
FOR EACH ROW 
BEGIN
INSERT INTO wbia_jdbc_eventstore (event_id, object_key, object_name, object_function, event_priority, event_status)
VALUES (event_seq.nextval,:N.pkey, 'JabdullaCustomerBG', 'Update', 1, 0);
  END;
/

INSERT INTO CUSTOMER (pkey,ccode,fname,lname) values('Test', 'ANITA','MEHTA','IBM');

UPDATE CUSTOMER SET fname='ABC', lname='XYZ', ccode='' WHERE pkey='Test';

